package com.cirmuller.maidaddition.threads;

package .tmp;

import com.cirmuller.maidaddition.Utils.CraftingTasks.AbstractCraftingTask;
import com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList;
import java.util.Collection;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.item.ItemStack;

public class CalculateMaterialsLackedThread extends Thread {
  ItemList materialsHave;
  
  ItemList materialsLacked;
  
  ItemList materialsToCraft;
  
  ServerLevel level;
  
  boolean isCalculated;
  
  public CalculateMaterialsLackedThread(ServerLevel level, ItemList materialsHave, ItemList materialsToCraft) {
    this.materialsHave = materialsHave.copy();
    this.materialsToCraft = materialsToCraft.copy();
    this.isCalculated = false;
    this.level = level;
  }
  
  public CalculateMaterialsLackedThread(ServerLevel level, ItemList materialsToCraft) {
    this(level, new ItemList(), materialsToCraft);
  }
  
  private ItemList getMaterialsUsedToCraft() {
    ItemList result = new ItemList();
    for (ItemStack itemStack : this.materialsToCraft)
      result.addAll((Collection)(new AbstractCraftingTask(this.level, itemStack.m_41720_(), Integer.valueOf(itemStack.m_41613_()))).getMaterialsList()); 
    return result;
  }
  
  private ItemList getMaterialDecomposition() {
    ItemList result = new ItemList();
    for (ItemStack itemStack : this.materialsHave)
      result.addAll((Collection)(new AbstractCraftingTask(this.level, itemStack.m_41720_(), Integer.valueOf(itemStack.m_41613_()))).getMaterialsList()); 
    return result;
  }
  
  public void run() {
    getMaterialsLacked();
  }
  
  public ItemList getMaterialsLacked() {
    if (!this.isCalculated) {
      this.materialsLacked = ItemList.subtract(getMaterialsUsedToCraft(), getMaterialDecomposition());
      this.isCalculated = true;
    } 
    return this.materialsLacked;
  }
}
